from pyspark.sql.types import (
    DecimalType,
    LongType,
    StringType,
    StructField,
    StructType,
)

# Schema definition for the ADA spreadsheets
schema: StructType = StructType(
    [
        StructField("id", StringType(), False),
        StructField("registration_number", StringType(), False),
        StructField("suffix", StringType(), True),
        StructField("sheet_name", StringType(), True),
        StructField("acquired_from_agent", StringType(), True),
        StructField("acquisition_date_string", StringType(), True),
        StructField("acquisition_residence", StringType(), True),
        StructField("additional_numbers_1_comment", StringType(), True),
        StructField("additional_numbers_1_type", StringType(), True),
        StructField("additional_numbers_1_value", StringType(), True),
        StructField("altitude_meters", DecimalType(), True),
        StructField("applied_preservative", StringType(), True),
        StructField("basis_of_record", StringType(), True),
        StructField("biotope_text", StringType(), True),
        StructField("collecting_date_end", StringType(), True),
        StructField("collecting_date_start", StringType(), True),
        StructField("collecting_date_string", StringType(), True),
        StructField("collecting_method", StringType(), True),
        StructField("collecting_time_end", StringType(), True),
        StructField("collecting_time_start", StringType(), True),
        StructField("collector_name", StringType(), True),
        StructField("collector_residence", StringType(), True),
        StructField("count", LongType(), True),
        StructField("count_approximate", LongType(), True),
        StructField("datagroup_description", StringType(), True),
        StructField("decimal_latitude_wgs84", DecimalType(), True),
        StructField("decimal_longitude_wgs84", DecimalType(), True),
        StructField("depth_meters", DecimalType(), True),
        StructField("detailed_specification_1_approximate", StringType(), True),
        StructField("detailed_specification_1_number_of_specimen", StringType(), True),
        StructField("detailed_specification_1_part", StringType(), True),
        StructField("detailed_specification_1_phase_or_stage", StringType(), True),
        StructField("detailed_specification_1_sex", StringType(), True),
        StructField("detailed_specification_2_approximate", StringType(), True),
        StructField("detailed_specification_2_number_of_specimen", StringType(), True),
        StructField("detailed_specification_2_part", StringType(), True),
        StructField("detailed_specification_2_phase_or_stage", StringType(), True),
        StructField("detailed_specification_2_sex", StringType(), True),
        StructField("detailed_specification_3_approximate", StringType(), True),
        StructField("detailed_specification_3_number_of_specimen", StringType(), True),
        StructField("detailed_specification_3_part", StringType(), True),
        StructField("detailed_specification_3_phase_or_stage", StringType(), True),
        StructField("detailed_specification_3_sex", StringType(), True),
        StructField("detailed_specification_4_approximate", StringType(), True),
        StructField("detailed_specification_4_number_of_specimen", StringType(), True),
        StructField("detailed_specification_4_part", StringType(), True),
        StructField("detailed_specification_4_phase_or_stage", StringType(), True),
        StructField("detailed_specification_4_sex", StringType(), True),
        StructField("determination_author_and_year", StringType(), True),
        StructField("determination_identifier", StringType(), True),
        StructField("determination_name_comments", StringType(), True),
        StructField("family_name", StringType(), True),
        StructField("full_name_no_authority", StringType(), True),
        StructField("full_scientific_name", StringType(), True),
        StructField("gatheringcoordinates_uncertainty_m", StringType(), True),
        StructField("gatheringsites_country", StringType(), True),
        StructField("gatheringsites_full_locality_text", StringType(), True),
        StructField("gatheringsites_island", StringType(), True),
        StructField("gatheringsites_locality", StringType(), True),
        StructField("gatheringsites_state_province", StringType(), True),
        StructField("genus", StringType(), True),
        StructField("height_meters", DecimalType(), True),
        StructField("higher_name_1_name", StringType(), True),
        StructField("higher_name_1_rank", StringType(), True),
        StructField("higher_name_2_name", StringType(), True),
        StructField("higher_name_2_rank", StringType(), True),
        StructField("identification_2_author_and_year", StringType(), True),
        StructField("identification_2_genus", StringType(), True),
        StructField("identification_2_identifier", StringType(), True),
        StructField("identification_2_name_comments", StringType(), True),
        StructField("identification_2_qualifier_entire_name", StringType(), True),
        StructField("identification_2_qualifier_species", StringType(), True),
        StructField("identification_2_qualifier_subspecies", StringType(), True),
        StructField("identification_2_species", StringType(), True),
        StructField("identification_2_start_date", StringType(), True),
        StructField("identification_2_subspecies", StringType(), True),
        StructField("identification_start_date", StringType(), True),
        StructField("mount", StringType(), True),
        StructField("phase_or_stage", StringType(), True),
        StructField("place_name", StringType(), True),
        StructField("place_type", StringType(), True),
        StructField("present_in_collection", StringType(), True),
        StructField("preservation", StringType(), True),
        StructField("preservation_technique", StringType(), True),
        StructField("preserved_part", StringType(), True),
        StructField("qualifier_entire_name", StringType(), True),
        StructField("qualifier_species", StringType(), True),
        StructField("qualifier_subspecies", StringType(), True),
        StructField("recorded_by_id", StringType(), True),
        StructField("registration_type", StringType(), True),
        StructField("remarks", StringType(), True),
        StructField("sample_id", StringType(), True),
        StructField("sex", StringType(), True),
        StructField("species", StringType(), True),
        StructField("station_number", StringType(), True),
        StructField("subfamily_name", StringType(), True),
        StructField("subgenus", StringType(), True),
        StructField("subspecies", StringType(), True),
        StructField("survey_name", StringType(), True),
        StructField("synecology_comment", StringType(), True),
        StructField("synecology_determination_type", StringType(), True),
        StructField("synecology_phase_or_stage", StringType(), True),
        StructField("synecology_scientific_or_informal_name", StringType(), True),
        StructField("synecology_sex", StringType(), True),
        StructField("type_status", StringType(), True),
        StructField("verbatim_coordinates", StringType(), True),
        StructField("additional_numbers_2_comment", StringType(), True),
        StructField("additional_numbers_2_type", StringType(), True),
        StructField("additional_numbers_2_value", StringType(), True),
        StructField("additional_numbers_3_comment", StringType(), True),
        StructField("additional_numbers_3_type", StringType(), True),
        StructField("additional_numbers_3_value", StringType(), True),
        StructField("bait_pheromones", StringType(), True),
    ]
)

if __name__ == "__main__":
    for struct_field in schema.fields:
        print(struct_field.name)

    print(schema.fieldNames())
